#!/usr/local/bin/python2.4

from bombardier_core.static_data import OK, FAIL
from bombardier_core.Spkg import SpkgV4
import shutil, sys, os
import yaml

metadata = {
    "package-version": 4,
    "install": {"reboot": "False",
                "priority": "100"},
    "dependencies": []
    }

class TestPackage(SpkgV4):

    def __init__(self, config, logger):
        SpkgV4.__init__(self, config, logger)
        self.thing = config.get("test", "value", "foo")
        self.directory = config.get("test", "directory", r"c:\test")
        self.test_path  = os.path.join(self.directory, "TEST.TXT")

    def configure(self):
        self.info( "configuring..." )
        if not os.path.isdir(self.directory):
            self.info("creating directory %s" % self.directory)
            os.makedirs(self.directory)
        open(self.test_path, 'w').write(self.thing)
        return OK

    def installer(self):
        self.info( "installing..." )
        self.configure()
        return OK

    def uninstaller(self):
        self.info( "uninstalling..." )
        os.unlink(self.test_path)
        if os.path.isdir(self.directory):
            self.info("removing directory %s" % self.directory)
            os.rmdir(self.directory)
        return OK

    def verify(self):
        self.info( "verify..." )
        if os.path.isdir(self.directory):
            data = open(self.test_path).read()
            if data == self.thing:
                return OK
        return FAIL
